<?php
if(!class_exists('DukaPress_Cart')) {

	class DukaPress_Cart{

		public static $cookie_id_string = 'dpsc_cart_';

		public static $error = "";

		static function init(){
			// use both actions so logged in and not logged in users can send this AJAX request
			add_action('wp_ajax_nopriv_dpsc_update_cart', array(__CLASS__, 'update_cart'));
			add_action('wp_ajax_dpsc_update_cart', array(__CLASS__, 'update_cart'));

			//Discount codes
			add_action('wp_ajax_nopriv_dpsc_validate_discount', array(__CLASS__, 'validate_discount'));
			add_action('wp_ajax_dpsc_validate_discount', array(__CLASS__, 'validate_discount'));
            
            //Process Cart
			add_action('wp_ajax_nopriv_dpsc_process_cart', array(__CLASS__, 'process_cart'));
			add_action('wp_ajax_dpsc_process_cart', array(__CLASS__, 'process_cart'));
            
            //Inquiry
            add_action('wp_ajax_nopriv_dpsc_inquire', array(__CLASS__, 'dpsc_inquire'));
			add_action('wp_ajax_dpsc_inquire', array(__CLASS__, 'dpsc_inquire'));
            
		}

		/**
		 * Get the cart cookis
		 *
		 */
		static function get_cart_cookie() {

			$cookie_id = self::$cookie_id_string . COOKIEHASH;

			if ( isset( $_COOKIE[ $cookie_id ] ) ) {
				$cart_items = stripslashes( $_COOKIE[ $cookie_id ] );
				$cart 		= json_decode( urldecode( $cart_items ), true );
			} else {
				$cart = array();
			}

			if ( isset( $cart) ) {
				return $cart;
			} else {
				return array();
			}
		}


		//saves cart array to cookie
		static function set_cart_cookie( $cart ) {

			$cookie_id = self::$cookie_id_string . COOKIEHASH;

			//set cookie
			$expire = strtotime( '+1 month' ); //1 month expire
			setcookie( $cookie_id, json_encode( $cart ), $expire, COOKIEPATH, COOKIE_DOMAIN );

			// Set the cookie variable as well, sometimes updating the cache doesn't work
			$_COOKIE[ $cookie_id ] = json_encode( $cart );
		}




		static function update_cart(){
			global $dukapress;

			//Get the cart
			$cart = self::get_cart_cookie();
            
			//Empty the cart
			if ( isset( $_POST[ 'empty_cart' ] ) ) {
				self::set_cart_cookie( array() );
				ob_start();
                echo self::dpsc_print_cart_html();
                $output = ob_get_contents();
                ob_end_clean();
                $output = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output));
                $output1 = self::dpsc_print_cart_html(TRUE);
                $output1 = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output1));
                $output2 = dukapress_cart_link(false);
                $output2 = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output2));
                echo "jQuery('div.dpsc-shopping-cart').html('$output');";
                echo "jQuery('div.dpsc-checkout').html('$output');";
                echo "jQuery('div.dpsc-mini-shopping-cart').html('$output1');";
                echo "jQuery('div.dpsc-checkout_url-widget').html('$output2');";
                exit();
			}else if ( isset( $_POST[ 'save_cart' ] ) ) {
				$product_id	 = intval( $_POST[ 'product_id' ] );
                $meta = get_post_custom($product_id);
                //unserialize
                foreach ($meta as $key => $val)
                    $meta[$key] = array_map('maybe_unserialize', $val);
                
				$product_variation_names = '';
    		    $product_variation_prices = 0.00;
				$product = get_post( $product_id );
                $product_name = $product->post_title;
				if ( !$product || $product->post_type != 'duka' || $product->post_status != 'publish' )
					return false;

					//get quantity
				$product_quantity = (isset( $_POST[ 'quantity' ] )) ? intval( abs( $_POST[ 'quantity' ] ) ) : 1;

				$product_max_quantity = get_post_meta($product_id, 'currently_in_stock', true);
                
                $product_sku = get_post_meta($product_id, 'sku', true);

				//get variation
				$variation = (isset( $_POST[ 'variation' ] )) ? intval( abs( $_POST[ 'variation' ] ) ) : 0;

				$check_max_qty = false;
                if ($dukapress->get_setting('inventory_active') && $product_max_quantity) {
                    if(intval($product_max_quantity) == 0)
                        $check_max_qty = true;
                    else if(intval($product_max_quantity) < intval($product_quantity)){
                        $check_max_qty = true;
                    }
                }

                $dpsc_products = self::get_cart_cookie();
                
                if(!$check_max_qty){
                    $product_weight = isset($_POST['product_weight']) ? intval($_POST['product_weight']) : 0;
                    if ( isset( $meta[ "price" ] ) && is_array( $meta[ "price" ] ) ) {
                        foreach ( $meta[ "price" ] as $key => $value ) {
                            if ( isset( $meta[ "new_price" ] ) && $meta[ "new_price" ] ) {
                                $product_base_price = $meta[ "new_price" ][ $key ] ;
                                $product_current_price = $value ;
                                $product_new_price = $meta[ "new_price" ][ $key ] ;
                            } else {
                                $product_base_price = $value ;
                                $product_current_price = $value ;
                                $product_new_price = 0;
                            }
                        }
                    } else {
                        $product_base_price = 0;
                        $product_current_price = 0 ;
                        $product_new_price = 0;
                    }
                    if (isset($_POST['var'])) {
                        $product_variations = $_POST['var'];
                        $product_variation_names = array();
                        if (is_array($product_variations)) {
                            foreach ($product_variations as $product_variation) {
                                $product_variation_tmp = explode(',:_._:,', $product_variation);
                                $product_variation_names[] = dpsc_variation_name($product_variation_tmp[0]);
                                $product_price = floatval($product_variation_tmp[1]);
                                $product_variation_prices += $product_price;
                            }
                        }
                        $product_variation_names = implode(', ', $product_variation_names);
                    } else {
                        $product_updated_price = $product_base_price;
                    }
                    $product_base_price = apply_filters('dukapress_product_base_price', $product_base_price, $product_id);
                    $check_updated_price = floatval($product_base_price + $product_variation_prices);
                    $check_updated_current_price = floatval($product_current_price + $product_variation_prices);
                    $check_updated_new_price = floatval($product_new_price + $product_variation_prices);
                    
                    $dpsc_count = 1;
                    if (is_array($dpsc_products)) {
                        foreach ($dpsc_products as $key => $item) {
                            if ($item['item_number'] === $product_id && $item['var'] === $product_variation_names) {
                                
                                $dpsc_count += $item['quantity'];
                                $item['max'] = $product_max_quantity;
                                $total_quantity = $product_quantity + $item['quantity'];
                                $check_max_qty = $product_max_quantity;
                                if (intval($product_max_quantity) == 0) {
                                    $check_max_qty = true;
                                }
                                if ($check_max_qty && $dukapress->get_setting('inventory_active')) {
                                    if ($total_quantity > intval($product_max_quantity)) {
                                        $product_quantity = $product_max_quantity;
                                        $item['quantity'] = $product_quantity;
                                    } else {
                                        $item['quantity'] += $product_quantity;
                                    }
                                } else {
                                    $item['quantity'] += $product_quantity;
                                }
                                unset($dpsc_products[$key]);
                                if ($item['quantity'] > 0) {
                                    array_push($dpsc_products, $item);
                                }
                            }
                        }
                    }else{
                        
                        $dpsc_product = array('var' => $product_variation_names, 'quantity' => $product_quantity, 'item_number' => $product_id, 'item_weight' => $product_weight, 'price' => $check_updated_price, 'current_price' => $check_updated_current_price, 'new_price' => $check_updated_new_price, 'name' => $product_name, 'sku' => $product_sku);
                        if (intval($product_quantity) > 0) {
                            array_push($dpsc_products, $dpsc_product);
                        }
                    }
                    if ($dpsc_count == 1) {
                        $dpsc_product = array('var' => $product_variation_names, 'quantity' => $product_quantity, 'item_number' => $product_id, 'item_weight' => $product_weight, 'price' => $check_updated_price, 'current_price' => $check_updated_current_price, 'new_price' => $check_updated_new_price, 'name' => $product_name, 'sku' => $product_sku);
                        if (intval($product_quantity) > 0) {
                            $dpsc_products[ $product_id ] = $dpsc_product;
                        }
                    }
                    sort($dpsc_products);
                    self::set_cart_cookie($dpsc_products);
                }
                ob_start();
                echo self::dpsc_print_cart_html(FALSE, $product->post_title);
                $output = ob_get_contents();
                ob_end_clean();
                $output = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output));
                $output1 = self::dpsc_print_cart_html(TRUE);
                $output1 = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output1));
                $output2 = dukapress_cart_link(false);
                $output2 = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output2));
                echo "jQuery('div.dpsc-shopping-cart').html('$output');";
                echo "jQuery('div.dpsc-mini-shopping-cart').html('$output1');";
                echo "jQuery('div.dpsc-checkout_url-widget').html('$output2');";
                echo "jQuery('form[id=product_form_" . $product_id . "]').addClass('product_in_cart');";
                exit();
                
			}else if ( isset( $_POST[ 'update_cart' ] ) ) {
				$product_id	 = intval( $_POST[ 'product_id' ] );
				$product_variation_names = '';
    		    $product_variation_prices = 0.00;
				$product = get_post( $product_id );
				if ( !$product || $product->post_type != 'duka' || $product->post_status != 'publish' )
					return false;
				$product_variation_name = trim($_POST['qpvar']);
	    	    $product_quantity = intval($_POST['quantity']);
				$product_max_quantity = get_post_meta(intval($product_id), 'currently_in_stock', true);
				$check_max_qty = false;
                if ($dukapress->get_setting('inventory_active') && $product_max_quantity) {
                    if(intval($product_max_quantity) == 0)
                        $check_max_qty = true;
                    else if(intval($product_max_quantity) < intval($product_quantity)){
                        $check_max_qty = true;
                    }
                }

				$dpsc_products = self::get_cart_cookie();
               
				if($product_quantity > 0){
                     if(!$check_max_qty){
                        if (is_array($dpsc_products)) {
                            foreach ($dpsc_products as $key => $item) {
                                if ($item['item_number'] === $product_id && $item['var'] === $product_variation_name) {
                                    $item['quantity'] = $product_quantity;
                                    unset($dpsc_products[$key]);
                                    if ($product_quantity > 0) {
                                    array_push($dpsc_products, $item);
                                    }
                                    break;
                                }
                            }
                        }
                     }

				}else{
					if (is_array($dpsc_products)) {
                       foreach ($dpsc_products as $key => $item) {
                            if ($item['item_number'] === $product_id && $item['var'] === $product_variation_name) {
                                unset($dpsc_products[$key]);
                            }
                        }
                    }
				}
				sort($dpsc_products);
				self::set_cart_cookie($dpsc_products);
                
                list($content, $dp_shipping_calculate_html) = self::dpsc_print_checkout_table_html();
                ob_start();
                echo $content;
                $output = ob_get_contents();
                ob_end_clean();
                $output = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output));
                echo "jQuery('div.dpsc-table-checkout').html('$output');";
                ob_start();
                echo self::dpsc_print_cart_html();
                $output1 = ob_get_contents();
                ob_end_clean();
                $output1 = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output1));
                $output2 = self::dpsc_print_cart_html(TRUE);
                $output2 = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output2));
                
                echo "jQuery('div.dpsc-checkout-product-list').html('$output');";
                echo "jQuery('div.dpsc-shopping-cart').html('$output1');";
                echo "jQuery('div.dpsc-mini-shopping-cart').html('$output2');";
                if ($dukapress->get_setting('shipping->method') === "ship_pro") {
                    echo "jQuery('#dpsc_make_payment').attr('disabled', true);";
                    echo "jQuery('input[name=dpsc_shipping_pro_location]:checked').attr('checked', false);";
                }
                if(empty($dpsc_products)){
                    echo "jQuery('div.dpsc-checkout').html('".__("Your cart is empty.","dp-lang")."');";
                }
				
			}
		}

		static function validate_discount(){
			global $dukapress;
			$discount_code = trim($_POST['dpsc_check_code']);
			$response = $dukapress->check_discount($discount_code);
			$dpsc_discount_value = 0.00;
			if($response['valid']){
                $dukapress->start_session();
				$dpsc_discount_value = $response['amount'];
                $_SESSION['dpsc_discount_value'] = $dpsc_discount_value;
				$_SESSION['dpsc_discount'] = $discount_code;
                session_write_close();
			}
			list($dpsc_checkout_html, $dp_shipping_calculate_html, $inputinfo) = self::dpsc_print_checkout_table_html($dpsc_discount_value);
			ob_start();
			echo $dpsc_checkout_html;
			$valid_output = ob_get_contents();
			ob_end_clean();
			$valid_output = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($valid_output));
            $inputinfo = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($inputinfo));
			echo "jQuery('div.dpsc-table-checkout').html('$valid_output');";
			if ($response['valid']) {
				echo "jQuery('input#dpsc_discount_code').val('" . $discount_code . "');";
                echo "jQuery('.dpsc_content_inputs').html('" . $inputinfo . "');";
				echo "jQuery('span#dpsc_check_discount_code').css('display', 'block').html('".__("Valid Discount Code","dp-lang")."');";
				exit();
			} else {
				echo "jQuery('span#dpsc_check_discount_code').css('display', 'block').addClass('dpsc_discount_code_invalid').html('".__("Invalid or Expired or Already Used","dp-lang")."');";
				 exit();
			}
		}

		/**
		 * Cart HTML
		 *
		 */
		static function dpsc_print_cart_html($mini=FALSE, $product_name = FALSE) {
		    $dpsc_output = '<div class="dpsc-shopping-cart">';
		    global $dukapress;
		    $dpsc_total_products = 0;
            $dpsc_total = 0.00;
            $dpsc_total_discount = 0.00;
			$cart = self::get_cart_cookie();
		    if (empty($cart)) {
		        $dpsc_output .= __('Your cart is empty.',"dp-lang");
		    }
            
		    else {
		        if (is_array($cart)) {
		           if($dukapress->get_setting('dp_shop_mode') != 'inquiry') {
		               $price_head = '<th id="price">' . __('Price',"dp-lang") . '</th>';
		           }
		           else {
		               $price_head = '';
		           }
		           if ($product_name) {
		               $dpsc_output .= '<div class="dpsc_update_notification">' . __('You have added',"dp-lang") . ' <strong>' . $product_name . '</strong> ' . __('to the cart',"dp-lang") . '.</div>';
		           }
                   $dpsc_discount_value = 0;
                   if(isset($_SESSION['dpsc_discount_value'])){
                        $dpsc_discount_value = $_SESSION['dpsc_discount_value'];
                   }
                   list($dpsc_checkout_html, $dp_shipping_calculate_html, $inputinfo) = self::dpsc_print_checkout_table_html($dpsc_discount_value);
                   $dpsc_output .= $dpsc_checkout_html;
                   $dpsc_output .= $dp_shipping_calculate_html;
		           
		            $dpsc_output .= '<div><span class="emptycart">
																 <a href="#" class="dpsc_empty_your_cart">' . __('Empty your cart',"dp-lang") . '</a>
		                						 </span></div>';
		            $dpsc_output .= "<span class='gocheckout'>" . dukapress_cart_link(false) . "</span>";
		        }
		    }
            $dpsc_output .= "</div>";
		    if ($mini) {
		        $dpsc_at_mini_price = '';
		        if($dukapress->get_setting('dp_shop_mode') != 'inquiry') {
		            $dpsc_at_mini_price = $dukapress->format_currency( '', $dpsc_total );
		        }
		        return '<div class="dpsc-mini-shopping-cart"><a href="' . dukapress_cart_link(false) . '">'. $dpsc_total_products . ' ' . __('Products',"dp-lang") . ' ' . $dpsc_at_mini_price . '</a></div>';
		    }
		    else {
		        return $dpsc_output;
		    }
		}


		static function dpsc_print_checkout_table_html($dpsc_discount_value = 0) {
		    global $dukapress;
            $dpsc_products = self::get_cart_cookie();
            $content = "";
            $content_inputs = "";
            $dp_shipping_calculate_html = "";
		    if (is_array($dpsc_products) && count($dpsc_products) > 0) {
		        $dpsc_total = 0.00;
				$tax_rate = $dukapress->get_setting('tax->rate');
		        $dpsc_tax_rate = !empty($tax_rate) ? $tax_rate : 0;

		        $dpsc_total_discount = 0.00;
		        $dpsc_total_shipping = 0.00;
		        $dpsc_total_tax = 0.00;
                $dp_shipping_price = 0;
		        if ($dukapress->get_setting('dp_shop_mode') != 'inquiry') {
		            $price_head_output = '<th>' . __("Price", "dp-lang") . '</th>';
		        } else {
		            $price_head_output = '';
		        }
		        $content .= '<div class="dpsc-checkout-product-list"><table>';
		        $content .= '<tr><th>' . __("Product", "dp-lang") . '</th><th>' . __("Quantity", "dp-lang") . '</th>' . $price_head_output . '<th /></tr>';
                $dpsc_weight = 0;
		        $dpsc_count_product = 1;
                $total_digital_products = 0;
		        foreach ($dpsc_products as $key => $dpsc_product) {
					$product = get_post($dpsc_product['item_number']);
		            $product_max_quantity = get_post_meta($product->ID, 'currently_in_stock', true);
		            $check_max_qty = $product_max_quantity;
		            if (intval($product_max_quantity) == 0) {
		                $check_max_qty = true;
		            }
		            if ($check_max_qty && $dukapress->get_setting('inventory_active')) {
		                if ($dpsc_product['quantity'] > intval($product_max_quantity)) {
		                    $dpsc_product['quantity'] = $product_max_quantity;
		                    unset($dpsc_products[$key]);
		                    if ($dpsc_product['quantity'] != 0) {
		                        array_push($dpsc_products, $dpsc_product);
		                    }
		                }
		            }
                    
                    if(Dukapress_Downloads::is_digital_file($product->ID)){
                        $total_digital_products++;
                    }
		            
				    $prod_price = $dpsc_product['price'] * $dpsc_product['quantity'];
					$prod_price = apply_filters( 'dukapress_cart_product_price', $prod_price, $dpsc_product);
                    $dpsc_total += floatval($prod_price);
		            $dpsc_var = '';
		            if (!empty($dpsc_product['var'])) {
		                $dpsc_var = ' (' . $dpsc_product['var'] . ')';
		            }
		            $dpsc_at_checkout_to_be_displayed_price = $dukapress->format_currency( '', $prod_price );
                    $dpsc_weight += $dpsc_product['item_weight'] * $dpsc_product['quantity'];
		            if ($dukapress->get_setting('dp_shop_mode') != 'inquiry') {
		                $price_row_output = '<td class="price">' . $dpsc_at_checkout_to_be_displayed_price . '</td>';
		            } else {
		                $price_row_output = $dukapress->format_currency( '', 0 );
		            }

		            $content .= '<tr><td>' . $product->post_title. __($dpsc_var, "dp-lang") . '</td>
		                <td class="quantity"><form method="post" class="dcps_update_cart">
		                <input type="hidden" name="product_id" value="' . $dpsc_product['item_number'] . '"/>
		                <input type="hidden" name="qpvar" value="' . $dpsc_product['var'] . '"/>
		                <input type="hidden" name="update_cart" value="update_quantity"/>
		                <input type="text" name="quantity" size="1" value="' . $dpsc_product['quantity'] . '"/>
                        <input type="hidden" name="action" value="dpsc_update_cart"/>
		                <input type="submit" value="' . __('Update', "dp-lang") . '" name="qupdate"></form></td>
		                ' . $price_row_output . '
		                <td><form action="" method="post" class="dcps_update_cart">
		                <input type="hidden" name="product_id" value="' . $dpsc_product['item_number'] . '"/>
		                <input type="hidden" name="quantity" value="0"/>
                        <input type="hidden" name="action" value="dpsc_update_cart"/>
		                <input type="hidden" name="update_cart" value="update_quantity"/>
		                <input type="hidden" name="qpvar" value="' . $dpsc_product['var'] . '"/>
		                <input type="submit" value="' . __('Remove', "dp-lang") . '" name="qupdate"></form></td></tr>';
		            $dpsc_count_product++;
		        }

		        $content .= '</table></div>';
		        if ($dukapress->get_setting('dp_shop_mode') != 'inquiry') {
		            $content .= '<table id="dpsc-final-price-display">';
		            $dpsc_discount_total_at_end = '';
		            $dpsc_total_discount = 0.00;
		            if ($dukapress->get_setting('discount') === 'true') {
		                $dpsc_total_discount = $dpsc_total * $dpsc_discount_value / 100;
                        //Dukapress Discount plugin. Check the product quantity and give the discount
                        global $dp_desc;
                        if(isset($dp_desc)){
                            $dp_desc_disc = dp_disc_prod_discount($dpsc_total_quantity);
                            $dpsc_total_discount += $dp_desc_disc['total'];
                            $dpsc_discount_value += $dp_desc_disc['value'];
                        }
										//End plugin
		                $dpsc_discount_total_at_end = '<tr id="dpsc-checkout-total-discount"><th>' . __("Discount:", "dp-lang") . '</th><td>-<span id="discount_total_price">' . $dukapress->format_currency( '', $dpsc_total_discount ) . '</span><input name="dpsc_discount_code_payment" type="hidden" value="' . $dpsc_discount_value . '"/></td></tr>';
		            }
		            $dpsc_tax_total_at_end = '';
					$tax = $dukapress->get_setting('tax->rate');
		            if (isset($tax) && $tax > 0) {
                        $dpsc_total_tax = ($dpsc_total - $dpsc_total_discount) * $tax / 100;
                        $dpsc_tax_total_at_end = '<tr id="dpsc-checkout-total-tax"><th>Tax:</th><td>+' .$dukapress->format_currency( '', $dpsc_total_tax ). '</td></tr>';
		            }
                    $dpsc_shipping_total_at_end = '';
                    $dp_shipping_calculate_html = '';
                    if($dukapress->get_setting('shipping_enabled')){
                        $dpsc_shipping_value = self::dpsc_pnj_calculate_shipping_price($dpsc_weight, $dpsc_total, $dpsc_count_product,$total_digital_products);
                        $dp_shipping_price_html = '<span id="shipping_total_price">'.$dukapress->format_currency( '', 0).'</span> ';
                        
                        //Get shhipping value from session variable
                        if (is_numeric($dpsc_shipping_value)) {
                            $dpsc_shipping_value_1 = is_numeric($dpsc_shipping_value) ? $dpsc_shipping_value : $_SESSION['dpsc_shiping_price'];
                            $dp_shipping_price = $dpsc_shipping_value_1;
                            $dp_shipping_price_html = '<span id="shipping_total_price">' . $dukapress->format_currency( '', $dp_shipping_price ). '</span> ';
                        }
                        if (!is_numeric($dpsc_shipping_value)) {
                            
                            switch ($dpsc_shipping_value) {
                                case 'ship_pro':
                                    if ($dpsc_shipping_weight > 0) {
                                        $dp_shipping_calculate_html = dp_shipping_pro_options();
                                    }
                                    break;

                                default:
                                    ob_start();
                                    do_action('dpsc_shipping_html_at_checkout');
                                    $dp_shipping_calculate_html = ob_get_contents();
                                    ob_end_clean();
                                    break;
                            }
                        }
                        $dpsc_shipping_total_at_end = '<tr id="dpsc-checkout-shipping-price"><th>' . __("Shipping:", "dp-lang") . '</th><td>+' . $dp_shipping_price_html . '</td></tr>';
                    }
		            $dpsc_product_price_at_end = '<tr id="dpsc-checkout-your-price"><th>' . __("Price:", "dp-lang") . '</th><td>' . $dukapress->format_currency( '', $dpsc_total ) . '</td></tr>';
					$total_price = $dpsc_total + $dp_shipping_price + $dpsc_total_tax - $dpsc_total_discount;
		            $dpsc_total_price_at_the_end = '<tr id="dpsc-checkout-total-price"><th>' . __("Total:", "dp-lang") . '</th><td><strong>' . $dukapress->format_currency( '', $total_price) . '</strong></td></tr>';
		            $content_inputs = '<input type="hidden" name="dpsc_total_value" value="' . $dpsc_total . '" />';
                    $content_inputs .= '<input type="hidden" name="dpsc_total_price" value="' . $total_price . '" />';
                    $content_inputs .= '<input type="hidden" name="dpsc_total_tax" value="' . $dpsc_total_tax . '" />';
                    $content_inputs .= '<input type="hidden" name="dpsc_total_discount" value="' . $dpsc_total_discount . '" />';
                    if($dukapress->get_setting('shipping_enabled')){
                        if (!is_numeric($dpsc_shipping_value)) {
                            $total_for_shipping = $dpsc_total + $dpsc_total_tax - $dpsc_total_discount;
                            $content_inputs .= '<input type="hidden" name="dpsc_total_hidden_value_for_shipping" value="' . $total_for_shipping . '" />';
                        }
                    }
		            $content .= $dpsc_product_price_at_end . $dpsc_shipping_total_at_end . $dpsc_tax_total_at_end . $dpsc_discount_total_at_end . $dpsc_total_price_at_the_end;
		            $content .= '</table><input type="hidden" name="custom_shipping_value" value="no_val" />';
                    $content_inputs .= '<input type="hidden" name="custom_shipping_value" value="no_val" />';
                }
		    }
		    return array($content, $dp_shipping_calculate_html,$content_inputs);
		}

		/**
		 * Discount Form
		 */
		static function dpsc_print_checkout_discount_form(){
            $code = "";
            if(isset($_SESSION['dpsc_discount']) && !empty($_SESSION['dpsc_discount'])){
                $code = $_SESSION['dpsc_discount'];
            }
            $output = '<div class="dpsc_discount_checkout_form">
                <span id="dpsc_discount_code_heading">' . __("Enter Discount Code", "dp-lang") . '</span>
                <table class="dpsc_discount_checkout_table">
                    <tr><th id="dpsc_your_code">' . __("Discount Code", "dp-lang") . '</th><td><input type="text" name="dpsc_discount_code" id="dpsc_discount_code" class="dpsc_discount_code" value="'.$code.'" /><br/><span class="dpsc_discount_code_invalid dpsc_error_msg" id="dpsc_check_discount_code">&nbsp;</span></td></tr>
                    <tr><th id="dpsc_check_code">&nbsp;</th><td><input type="submit" class="dpsc_validate_discount_code" name="dpsc_validate_discount_code" value="' . __("Check", "dp-lang") . '" /></td></tr>
                </table>
            </div>';
    		return $output;
		}

		/**
		 * The Checkout table
		 *
		 */
		static function dpsc_print_checkout_html($layout = 'flat') {
			global $dukapress;
			$output = '';
			$dpsc_products = self::get_cart_cookie();
			if (is_array($dpsc_products) && count($dpsc_products) > 0) {
				$output .= '<span id="dpsc-checkout-text">' . __("Please review your order", 'dp-lang') . '</span>';
                $dpsc_discount_value = 0.00;
                if(isset($_SESSION['dpsc_discount_value']) && !empty($_SESSION['dpsc_discount_value'])){
                    $dpsc_discount_value = $_SESSION['dpsc_discount_value'];
                }
                list($dpsc_checkout_html, $dp_shipping_calculate_html,$content_inputs) = self::dpsc_print_checkout_table_html($dpsc_discount_value);
				$output .= '<div class="clear"></div><div class="dpsc-table-checkout">' . $dpsc_checkout_html . '</div>';
				if ($dukapress->get_setting('dp_shop_mode') != 'inquiry') {
					if ($dukapress->get_setting('discount') === 'true') {
						$output .= '<div class="clear"></div>' . self::dpsc_print_checkout_discount_form();
					}
					$output .= $dp_shipping_calculate_html;
                    $output .= '<form class="dcps_process_cart">';
					$output .= self::dpsc_pnj_show_checkout_information($layout);
                    $output .= '<div class="dpsc_content_inputs">';
                    $output .= $content_inputs;
                    $output .= '</div>';
					$output .= '<div class="clear"></div>' . self::dpsc_print_checkout_payment_form();
                    $output .= '</form>';
				}else{
					$output .= '<div class="clear"></div>' . self::dpsc_print_checkout_inquiry_form();
				}
			}else {
	           $output .= __("There are no products in your cart.", 'dp-lang');
            }
            return $output;
		}

		/**
		 * Dynamic Checkout Table
		 *
		 */
		static function dpsc_pnj_show_checkout_information($layout = 'flat') {
            global $dukapress;
            $checkout_settings = get_option( 'dukapress_checkout_settings' );
            if (is_array($checkout_settings) && count($checkout_settings) > 0) {
                $elem = ($layout == 'flat') ? "table": "div";
                $elem_row = ($layout == 'flat') ? "tr": "div";
                $elem_column = ($layout == 'flat') ? "td": "div";
                $content = '<'.$elem.' class="dpsc_checkout_table">';
                $count = 0;
                foreach ($checkout_settings as $checkout_row) {
                    if($checkout_row['visible'] == 'checked'){
                        $form_class = '';
                        $required_attr = '';
                        if($checkout_row['mandatory'] == 'checked'){
                            $form_class = 'required';
                            $required_attr = 'required="required"';
                        }
                        $hidden_class = '';
                        $input_elem = '';
                        $input_type = $checkout_row['type'];
                        $no_shipping = false;
                        if (strpos($checkout_row['uname'],'shipping') !== false && !$dukapress->get_setting('shipping_enabled')){
                            $no_shipping = true;
                        }
                        if(!$no_shipping){
                            if (strpos($checkout_row['uname'],'shipping') !== false){
                                $hidden_class = ' dpsc_shipping_hidden';
                                $required_attr = "";
                            }
                            switch($input_type){
                                case 'text' :
                                    $input_elem = '<input type="text" class="'.$form_class.' '.$checkout_row['uname'].'_input" name="'.$checkout_row['uname'].'" '.$required_attr.' placeholder="'.$checkout_row['initial'].'" id="'.$checkout_row['uname'].'" />';
                                    break;
                                case 'textarea' :
                                    $input_elem = '<textarea class="'.$form_class.' '.$checkout_row['uname'].'_input" name="'.$checkout_row['uname'].'" id="'.$checkout_row['uname'].'" '.$required_attr.' placeholder="'.$checkout_row['initial'].'"></textarea>';
                                    break;
                                case 'checkbox' :
                                    $input_elem = '<input type="checkbox" class="'.$form_class.' '.$checkout_row['uname'].'_input" name="'.$checkout_row['uname'].'" id="'.$checkout_row['uname'].'" '.$required_attr.'/>';
                                    break;
                                case 'paragraph' :
                                    $input_elem = '<p class="'.$form_class.' '.$checkout_row['uname'].'_input">'.$checkout_row['initial'].'</p>';
                                    break;
                                case 'select' :
                                    $countries = $dukapress->get_countries();
                                    if($dukapress->get_setting('shop_restrict_country')){
                                        $shop_country = $dukapress->get_setting('shop_country');
                                        $input_elem = '<input type="hidden" class="'.$form_class.' '.$checkout_row['uname'].'_input" name="'.$checkout_row['uname'].'" value="'.$shop_country.'" id="'.$checkout_row['uname'].'" />';
                                        $input_elem .= '<p class="'.$form_class.' '.$checkout_row['uname'].'_input">'.$countries[$shop_country].'</p>';
                                    }else{
                                        $input_elem = '<select class="'.$form_class.' '.$checkout_row['uname'].'_input">';
                                        $input_elem .= '<option value="">'.$checkout_row['initial'].'</option>';
                                        foreach ($countries as $country_code => $country_name) {
                                            $input_elem .= '<option value="' . $country_code . '">' . $country_name . '</option>';
                                        }
                                        $input_elem .= '</select>';
                                    }
                                    break;
                            }
                            $content .= "<$elem_row class='dpsc_row $hidden_class'>";
                            $content .= "<$elem_column class='dpsc_column'>";
                            $content .= '<label for="'.$checkout_row['uname'].'" class="'.$checkout_row['uname'].'">'.$checkout_row['name'].'</label>';
                            $content .= "</$elem_column>";
                            $content .= "<$elem_column class='dpsc_column'>";
                            $content .= $input_elem;
                            $content .= "</$elem_column>";
                            $content .= "</$elem_row>";
                        }
                    }
                    
                }
                if($dukapress->get_setting('shipping_enabled')){
                    $content .= "<$elem_row class='dpsc_row'>";
                    $content .= "<$elem_column class='dpsc_column'>";
                    $content .= '<label for="diffrent_shipping" class="dpsc_different_shipping">'.__('I have a different shipping address','dp-lang').'</label>';
                    $content .= "</$elem_column>";
                    $content .= "<$elem_column class='dpsc_column'>";
                    $content .= "<input type='checkbox' value='' class='dpcs_enable_shipping' />";
                    $content .= "</$elem_column>";
                    $content .= "</$elem_row>";
                    
                }
                $terms_url = dukapress_page_url(false, 'terms');
                if(!empty($terms_url)){
                    $content .= "<$elem_row class='dpsc_row'>";
                    $content .= "<$elem_column class='dpsc_column'>";
                    $content .= '<label for="terms_url" class="dpsc_terms_url">'.__('I agree to the ','dp-lang').'<a href="'.$terms_url.'" target="_blank">'.__('terms and conditions','dp-lang').'</a></label>';
                    $content .= "</$elem_column>";
                    $content .= "<$elem_column class='dpsc_column'>";
                    $content .= "<input type='checkbox' value='' class='dpcs_terms_agreed required' required='required'/>";
                    $content .= "</$elem_column>";
                    $content .= "</$elem_row>";
                }
                $content .= "</$elem>";
                return $content;
            }else{
                return __("No checkout fields available. Please check your settings", 'dp-lang');
            }
            
		}

		/**
		 * Payment Form
		 */
		static function dpsc_print_checkout_payment_form($layout = 'flat'){
            global $dukapress;
            $dpsc_selected_gateway_plugins = get_option( 'dpsc_selected_gateway_plugins' );
            if (is_array($dpsc_selected_gateway_plugins) && count($dpsc_selected_gateway_plugins) > 0) {
                $total = count($dpsc_selected_gateway_plugins);
                $content = "";
                $elem_table = ($layout == 'flat') ? "table": "div";
                if($total > 1)
                    $content .= "<$elem_table class='dpsc_row'>";
                foreach ($dpsc_selected_gateway_plugins as $dpsc_gateway) {
                    $content .= apply_filters('dpsc_payment_cart_'.$dpsc_gateway,$layout,$total);
                }
                if($total > 1)
                    $content .= "</$elem_table>";
                if($total > 1){
                    $content .= "<br/><input type='submit' class='order_submit_button' value='".__('Submit Order','dp-lang')."' />";
                }
                $content .= "<input type='hidden' name='action' value='dpsc_process_cart' />";
                return $content;
            }else{
                return __("No active gateways available", 'dp-lang');
            }
		}

		/**
		 * Inquiry Form
		 */
		//Finish this. Needs to post to a proper action
		static function dpsc_print_checkout_inquiry_form(){
			$output = '<div id="dpsc_inquiry_form">';
            $output .= '<form name="dpsc_inquiry_form" action="" class="dpsc_inquiry_form" method="POST">';
            $output .= '<label for="dpsc_inquiry_from_name">' . __("Your Name:", "dp-lang") . ' </label><br/><input id="dpsc_inquiry_from_name" name="dpsc_inquiry_from_name" type="text" value="" required="required"/><br/>';
            $output .= '<label for="dpsc_inquiry_from">' . __("Your Email:", "dp-lang") . ' </label><br/><input id="dpsc_inquiry_from" name="dpsc_inquiry_from" type="text" value="" required="required"/><br/>';
            $output .= '<label for="dpsc_inquiry_subject">' . __("Subject:", "dp-lang") . ' </label><br/><input id="dpsc_inquiry_subject" name="dpsc_inquiry_subject" type="text" value="" required="required"/><br/>';
            $output .= '<label for="dpsc_inquiry_custom_msg">' . __("Message:", "dp-lang") . ' </label><br/><textarea id="dpsc_inquiry_custom_msg" name="dpsc_inquiry_custom_msg" required="required"></textarea><br/>';
            $output .= '<input type="hidden" name="action" value="dpsc_inquire"/>';
            $output .= '<input type="submit" name="dpsc_inquire_submit" value="'.__("Ask For Quote","dp-lang").'"/>';
            $output .= '</form>';
            $output .= '</div>';
            return $output;
		}

        
        /**
         *
         * Calculate cart price
         */
        static function dpsc_pnj_calculate_shipping_price($dpsc_shipping_weight, $dpsc_total, $number_of_items_in_cart,$total_digital_products){
            global $dukapress;
            $number_of_items_in_cart = $number_of_items_in_cart - $total_digital_products; //remove digital products
            $shipping_method = $dukapress->get_setting('shipping->method');
            if($number_of_items_in_cart === 0){
                $shipping_method = 'free';
            }
            switch ($shipping_method) {
                case 'free':
                    $shipping_price = 0.00;
                    break;

                case 'flat':
                    $shipping_price = $dukapress->get_setting('shipping->flat_rate');
                    break;

                case 'flat_limit':
                    $flat_limit = $dukapress->get_setting('shipping->flat_limit_rate');
                    $flat_limit = explode('|', $flat_limit);
                    $flat_limit_rate = $flat_limit[0];
                    $flat_limit_cutoff = $flat_limit[1];
                    if ($sub_total_price > $flat_limit_cutoff) {
                        $shipping_price = 0.00;
                    } else {
                        $shipping_price = $flat_limit_rate;
                    }
                    break;

                case 'weight_flat':
                    $per_kg_price = $dukapress->get_setting('shipping->weight_flat_rate');
                    $weight_in_kg = $shipping_weight / 1000;
                    $shipping_price = $weight_in_kg * $per_kg_price;
                    break;


                case 'weight_class':
                    $weight_class = $dukapress->get_setting('shipping->weight_class_rate');
                    $wClasses = array();
                    $param = $weight_class;
                    $kg = $shipping_weight / 1000;
                    $p = explode("#", $param);

                    foreach ($p as $v) {
                        $a = explode("|", $v);
                        $wClasses["$a[1]"] = $a[0];
                    }

                    foreach ($wClasses as $k => $v) {

                        $b = explode("-", $v);

                        if ($b[1] == 'ul') {
                            $b[1] = $kg + 100.00;
                        }

                        $b[0] = (float) $b[0];
                        $b[1] = (float) $b[1];

                        if ($b[1] > 1.00) {
                            $b[1] = $b[1] + 0.0001;
                        } else {
                            $b[1] = $b[1] + 0.0001;
                        }


                        if ($kg > $b[0] && $kg < $b[1]) {
                            $sFee = $k;
                        }
                    }
                    $shipping_price = $sFee;
                    break;

                case 'per_item':
                    $per_item_rate = $dukapress->get_setting('shipping->per_item_rate');
                    $shipping_price = $per_item_rate * $number_of_items_in_cart;
                    break;

                case 'item_numbers':
                    $shipping_price = 0.00;
                    break;

                case 'ship_pro':
                    $shipping_price = 'ship_pro';
                    break;

                default:
                    $shipping_price = 'Addon';
                    break;
            }
            return $shipping_price;
        }
        
        /**
         * Process the cart
         *
         */
        static function process_cart(){
            global $dukapress;
            $dpsc_gateway_plugins = get_option('dpsc_gateway_plugins');
            $checkout_settings = get_option( 'dukapress_checkout_settings' );
            $cart = self::get_cart_cookie();
			if (is_array($cart) && count($cart) > 0) {
                $shipping_info = array();
                $user_info = array();
                $payment_info = array();
                $gateway_slug = $_POST['dpsc_gateway_option'];
                $gateway_info = $dpsc_gateway_plugins[$gateway_slug];
                $payment_info['mode'] = $gateway_slug;
                $payment_info['name'] = $gateway_info[1];
                
                $order_total = $_POST['dpsc_total_price'];
                $order_price = $_POST['dpsc_total_value'];
                $order_tax = $_POST['dpsc_total_tax'];
                $order_discount = $_POST['dpsc_total_discount'];
                $coupon_code = false;
                if(isset($_SESSION['dpsc_discount']) && !empty($_SESSION['dpsc_discount'])){
                    $coupon_code = $_SESSION['dpsc_discount'];
                    if(isset($_SESSION['dpsc_discount_value']) && !empty($_SESSION['dpsc_discount_value'])){
                        $order_discount = $_SESSION['dpsc_discount_value'];
                    }
                    $dukapress->start_session();
                    unset($_SESSION['dpsc_discount']);
                    unset($_SESSION['dpsc_discount_value']);
                    $dukapress->update_discount_usage($coupon_code);
                    session_write_close();
                }
                
                if($dukapress->get_setting('shipping_enabled'))
                    if(isset($_POST['dpsc_total_hidden_value_for_shipping']))
                        $order_shipping= $_POST['dpsc_total_hidden_value_for_shipping'];
                    else
                        $order_shipping=false;
                else
                    $order_shipping=false;
                
                $user_id = false;
                
                $predef_keys = array("dpsc_gateway_option", "dpsc_total_price", "dpsc_total_value", "dpsc_total_tax","dpsc_total_discount","dpsc_total_hidden_value_for_shipping");
                
                foreach($_POST as $key => $value){
                    if(!in_array($key, $predef_keys)){
                        
                        $array_position =  array_search($key, array_column($checkout_settings, 'uname')); //Search by the uname
                        if($array_position !== FALSE ){
                            $checkout_setting = $checkout_settings[$array_position];
                            $checkout_setting['value'] = $value;
                            if (strpos($key,'shipping') !== false && $dukapress->get_setting('shipping_enabled')){
                                $shipping_info[] = $checkout_setting;
                            }else{
                                $user_info[] = $checkout_setting;
                            }
                        }
                    }
                }
                $paid = false;
                if($order_total <= 0){
                    $paid = true;
                }
                
                $order_id = $dukapress->create_order('', $cart, $user_info, $shipping_info, $payment_info, $paid, $order_total, $user_id,  $order_shipping, $order_tax, $order_discount, $coupon_code);
                if($order_id){
                    $dukapress->ga_ecommerce($dukapress->get_order($order_id)); //Analytics
                    $meta = get_post_custom($order_id);
                    DukaPress_Mail::new_order_notification($user_info, $shipping_info, $order_id);
                    
                    $return_path = dukapress_page_url(false, 'thankyou');
                    $check_return_path = explode('?', $return_path);
                    if (count($check_return_path) > 1) {
                        $return_path .= '&id=' . $order_id;
                    } else {
                        $return_path .= '?id=' . $order_id;
                    }
                    self::set_cart_cookie( array() ); //clear cart
                    if (is_array($cart) && count($cart) > 0) {
                        do_action('dpsc_payment_submit_'.$gateway_slug,$cart, $user_info, $shipping_info, $order_id,$order_shipping,$order_discount, $order_tax,$order_price,$return_path);
                    }else{
                        $output = '<p>'.__("An Error Occured. Please try again later","dp-lang").'</p>';
                        echo "jQuery('div.dpsc-checkout').html('$output');";
                    }
                    exit();
                }else{
                    echo "alert('".__('An error occured completing the order. Please try again','dp-lang')."')";
                    exit();
                }
            }
        }
        
        /**
         * Process Inquiries
         *
         */
        static function dpsc_inquire(){
            global $dukapress;
            $cart = self::get_cart_cookie();
			if (is_array($cart) && count($cart) > 0) {
                $name = $_POST['dpsc_inquiry_from_name'];
                $email = $_POST['dpsc_inquiry_from'];
                $subject = $_POST['dpsc_inquiry_subject'];
                $message = $_POST['dpsc_inquiry_custom_msg'];
                DukaPress_Mail::enquiry_mail($cart, $name, $email, $subject, $message);
                self::set_cart_cookie( array() ); //clear cart
                $return_path = dukapress_page_url(false, 'thankyou');
                $check_return_path = explode('?', $return_path);
                if (count($check_return_path) > 1) {
                    $return_path .= '&action=inquiry';
                } else {
                    $return_path .= '?action=inquiry';
                }
                echo "window.location.href='$return_path'";
                exit();
            }else{
                echo "alert('".__('An error occured completing the order. Please try again','dp-lang')."')";
                exit();
            }
        }

	}
}
?>
