<?php
if(!class_exists('DukaPress_Gateway')) {

	class DukaPress_Gateway{

		//private plugin name visible to admin
		var $plugin_name = '';
        
        //private plugin public name of cart
		var $plugin_public_name = '';

		//private gateway slug. Lowercase alpha (a-z) and dashes (-) only please!
		var $plugin_slug = '';

		//always contains the url to send payment notifications to if needed by your gateway. Populated by the parent class
		var $ipn_url;

		var $return_url;

		var $cancel_url;

		//Determine if to use form submit or other method
		var $form_submit = true;

		//Supported Currencies
		var $currencies;

		var $error = false;

		var $error_message = "";

		//Do not overide
		function __construct() {
			$this->on_create();

			//check required vars
			if (empty($this->plugin_name) || empty($this->plugin_slug))
				wp_die( __("You must override all required vars in your payment gateway plugin!", "dp-lang") );
			$this->set_up_ipn_url();
            if(empty($this->plugin_public_name)){
                $this->plugin_public_name = $this->plugin_name;
            }


			add_action( 'dpsc_payment_submit_' . $this->plugin_slug, array(&$this, 'process_payment_form'), 10, 9 ); //Submit gateway
			add_action( 'dpsc_payment_return_'. $this->plugin_slug, array(&$this, 'process_ipn_return') ); //Process IPN
			add_action( 'dpsc_gateway_option_'. $this->plugin_slug , array(&$this, 'set_up_options'), 10, 1 ); //Set up options
			add_filter( 'dpsc_payment_update_'. $this->plugin_slug , array(&$this, 'update_payment'), 10, 1 ); //Update Payment
            add_filter('dpsc_payment_cart_'. $this->plugin_slug, array(&$this, 'cart'), 10, 2); //Cart options

			global $dukapress;
			//Register the plugin
			$dukapress->register_gateway(get_class($this), $this->plugin_name, $this->plugin_slug);
		}

		/**
		 * Runs when your class is instantiated. Use to setup your plugin instead of __construct()
		 */
		function on_create(){
		}


		//Sets Up IPN URL
		//Do not overide
		function set_up_ipn_url(){
			$this->ipn_url = home_url('payment-return/' . $this->plugin_slug);
			$checkout_path = urlencode(dukapress_page_url(false,'thankyou'));
            $check_return_path = explode('?', $checkout_path);
			$cancel_path = $checkout_path;
            if (count($check_return_path) > 1) {
                $cancel_path .= '&cancel=1';
            } else {
                $cancel_path .= '?cancel=1';
            }
			$this->return_url = $checkout_path;
			$this->cancel_url = $cancel_path;
		}

		/**
		 * Process Payment
		 */
		function process_payment_form($cart, $user_info, $shipping, $order_id, $total_shipping, $total_discount, $total_tax,$dpsc_total, $return_path){

		}

		function process_ipn_return(){

		}


		/**
		 * Set Up Payment gateway options
		 */
		function set_up_options($settings){
		}

		/**
		 * Update payment status
		 *
		 */
		function update_payment($request){
            return isset($_GET['status']) ? $_GET['status'] : FALSE;
		}
        
        /**
         * This is used on the checkout cart
         */
        function cart($layout, $total){
            $content = "";
            $elem_row = ($layout == 'flat') ? "tr": "div";
            $elem_column = ($layout == 'flat') ? "td": "div";
            if($total > 1){
                $content .= "<$elem_row class='dpsc_row'>";
                $content .= "<$elem_column class='dpsc_column'>";
                $content .= '<label for="'.$this->plugin_slug.'" class="dpsc_payment_option">'.$this->plugin_public_name.'</label>';
                $content .= "</$elem_column>";
                $content .= "<$elem_column class='dpsc_column'>";
                $content .= "<input type='radio' required='required' class='required dpsc_gateway $this->plugin_slug' name='dpsc_gateway_option' value='$this->plugin_slug'/>";
                $content .= "</$elem_column>";
                $content .= "</$elem_row>";
            }else{
                $content = "<input type='hidden' name='dpsc_gateway_option' value='$this->plugin_slug'/>";
                $content .= "<input type='submit' class='order_submit_button' value='".__('Pay Using','dp-lang')." $this->plugin_public_name' />";

            }
            return $content;
        }
        
        function send_gateway_output($output){
            $output = str_replace(Array("\n", "\r"), Array("\\n", "\\r"), addslashes($output));
            
            echo "jQuery('div.dpsc-checkout').html('$output');";
            if($this->form_submit){
                echo "jQuery('#dpsc_payment_form').submit();";
            }
        }
	}
}
?>
