<?php

if(!class_exists('DukaPress_Checkout_Link')) {
	add_action( 'widgets_init', 'dpsc_register_checkout_link_widget' );
	
	function dpsc_register_checkout_link_widget() {
		register_widget("DukaPress_Checkout_Link");
	}
	/**
	 * Widget for the cart
	 */
	class DukaPress_Checkout_Link extends WP_Widget{
	
		function __construct() {
			$widget_ops = array('classname' => 'dukapress_checkout', 'description' => __('Displays DukaPress Checkout Link',"dp-lang"));
			parent::__construct( 'dukapress_checkout_widget', __('Displays DukaPress Checkout Link'), $widget_ops);
		}
		
		function form($instance) {
			$instance = wp_parse_args( (array) $instance, array(  'title' => '') );
			$title = esc_attr( $instance['title'] );
			?>
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:',"dp-lang");?></label>
				<input type="text" value="<?php echo $title; ?>" name="<?php echo $this->get_field_name('title'); ?>" id="<?php echo $this->get_field_id('title'); ?>" class="widefat" />
			</p>
			<?php
		}
		
		function update($new_instance, $old_instance) {
			$instance = $old_instance;
			$instance['title'] = strip_tags( $new_instance['title'] );
			return $instance;
		}
		
		function widget($args, $instance) {
			extract($args);
			$title = empty( $instance['title'] ) ? '' : __($instance['title'],"dp-lang");
			echo $before_widget;
			if(!empty($title))
				echo $before_title.$title.$after_title;
			?>
			<div class="dpsc-shopping-cart" id="dpsc-shopping-cart">
				<?php dukapress_cart_link(true,false,''); ?>
			</div>
			<?php
			echo $after_widget;
		}
	}
}
?>