<?php

if(!class_exists('DukaPress_Custom_Search')) {
		
	add_action( 'widgets_init', 'dpsc_register_custom_search_widget' );
	
	function dpsc_register_custom_search_widget() {
		register_widget("DukaPress_Custom_Search");
	}
	/**
	 * Widget for the cart
	 */
	class DukaPress_Custom_Search extends WP_Widget{
	
		function __construct() {
			$widget_ops = array('classname' => 'dukapress_search', 'description' => __('Search Widget For DukaPress Products',"dp-lang"));
			parent::__construct( 'dukapress_search_widget', __('DukaPress Custom Search'), $widget_ops);
		}
		
		function form($instance) {
			$instance = wp_parse_args( (array) $instance, array(  'title' => '') );
			$title = esc_attr( $instance['title'] );
			?>
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:',"dp-lang");?></label>
				<input type="text" value="<?php echo $title; ?>" name="<?php echo $this->get_field_name('title'); ?>" id="<?php echo $this->get_field_id('title'); ?>" class="widefat" />
			</p>
        <?php
		}
		
		function update($new_instance, $old_instance) {
			$instance = $old_instance;
			$instance['title'] = strip_tags( $new_instance['title'] );
			return $instance;
		}
		
		function widget($args, $instance) {
			extract($args);
			$title = empty( $instance['title'] ) ? '' : __($instance['title'],"dp-lang");
			echo $before_widget;
			if (!empty($title)) {
				echo $before_title.$title.$after_title;
			}
			?>
			<div class="dpsc_search_widget">
				<form role="search" method="get" id="searchform" action="<?php echo home_url( '/' ); ?>">
					<input type="hidden" name="post_type" value="duka" />
					<input type="text" name="s" id="s" value="<?php _e('Enter keywords','dp-lang'); ?> ..." onfocus="if(this.value==this.defaultValue)this.value='';" onblur="if(this.value=='')this.value=this.defaultValue;"/>
					
					<input type="submit" id="searchsubmit" value="<?php _e('Search Products','dp-lang'); ?>" />
				</form>
			</div>
			<?php
			echo $after_widget;
		}
	}
}
?>